2011-07-26 20:28:49 +02:00
#!/bin/sh
2011-07-11 18:56:29 +02:00
2020-05-14 23:25:51 +02:00
# This script ensures that ep-lite is automatically restarting after
# an error happens
2011-07-11 18:56:29 +02:00
2020-05-14 23:25:51 +02:00
# Handling Errors
# 0 silent
# 1 email
2011-07-11 18:56:29 +02:00
ERROR_HANDLING = 0
2017-09-14 13:33:27 +02:00
# Your email address which should receive the error messages
2011-07-11 18:56:29 +02:00
EMAIL_ADDRESS = "no-reply@example.com"
2019-10-20 02:09:22 +02:00
# Sets the minimum amount of time between the sending of error emails.
# This ensures you do not get spammed during an endless reboot loop
2011-07-11 18:56:29 +02:00
# It's the time in seconds
TIME_BETWEEN_EMAILS = 600 # 10 minutes
# DON'T EDIT AFTER THIS LINE
2020-05-14 23:28:53 +02:00
pecho( ) { printf %s\\ n " $* " ; }
log( ) { pecho " $@ " ; }
error( ) { log " ERROR: $@ " >& 2; }
fatal( ) { error " $@ " ; exit 1; }
2011-07-11 18:56:29 +02:00
LAST_EMAIL_SEND = 0
2020-06-02 04:45:11 +02:00
LOG = " $1 "
2011-07-11 18:56:29 +02:00
2020-05-14 23:25:51 +02:00
# Move to the folder where ep-lite is installed
2020-05-14 23:43:45 +02:00
cd " $( dirname " $0 " ) " /..
2011-07-11 18:56:29 +02:00
2020-05-14 23:25:51 +02:00
# Check if a logfile parameter is set
2020-05-14 23:36:16 +02:00
[ -n " ${ LOG } " ] || fatal "Set a logfile as the first parameter"
2011-07-11 18:56:29 +02:00
2020-06-02 04:45:11 +02:00
shift
2020-05-14 23:43:04 +02:00
while true; do
2020-05-14 23:25:51 +02:00
# Try to touch the file if it doesn't exist
2020-05-14 23:40:16 +02:00
[ -f " ${ LOG } " ] || touch " ${ LOG } " || fatal " Logfile ' ${ LOG } ' is not writeable "
2019-10-20 02:09:22 +02:00
2020-05-14 23:25:51 +02:00
# Check if the file is writeable
2020-05-14 23:40:16 +02:00
[ -w " ${ LOG } " ] || fatal " Logfile ' ${ LOG } ' is not writeable "
2011-07-11 18:56:29 +02:00
2020-05-14 23:25:51 +02:00
# Start the application
2020-05-14 23:40:16 +02:00
bin/run.sh " $@ " >>${ LOG } 2>>${ LOG }
2019-10-20 02:09:22 +02:00
2020-05-14 23:25:51 +02:00
# Send email
2020-05-14 23:40:16 +02:00
if [ " $ERROR_HANDLING " = 1 ] ; then
2011-07-11 18:56:29 +02:00
TIME_NOW = $( date +%s)
TIME_SINCE_LAST_SEND = $(( $TIME_NOW - $LAST_EMAIL_SEND ))
2019-10-20 02:09:22 +02:00
2020-05-14 23:40:16 +02:00
if [ " $TIME_SINCE_LAST_SEND " -gt " $TIME_BETWEEN_EMAILS " ] ; then
printf " Server was restarted at: $( date) \nThe last 50 lines of the log before the error happens:\n $( tail -n 50 " ${ LOG } " ) " | mail -s "Pad Server was restarted" " $EMAIL_ADDRESS "
2019-10-20 02:09:22 +02:00
2011-07-11 18:56:29 +02:00
LAST_EMAIL_SEND = $TIME_NOW
fi
fi
2019-10-20 02:09:22 +02:00
2020-05-14 23:28:53 +02:00
pecho "RESTART!" >>${ LOG }
2019-10-20 02:09:22 +02:00
2020-05-14 23:25:51 +02:00
# Sleep 10 seconds before restart
2011-07-11 18:56:29 +02:00
sleep 10
done